"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var protractor_1 = require("protractor");
var e2e_server_1 = require("./e2e.server");
var e2e_utils_1 = require("./e2e.utils");
describe('e2e test preboot', function () {
    beforeAll(e2e_server_1.startServer);
    afterAll(e2e_server_1.stopServer);
    it('should validate server view', function () {
        e2e_utils_1.loadServerView()
            .then(function () { return protractor_1.element(protractor_1.by.css('h1')).getText(); })
            .then(function (text) { return expect(text).toEqual('server view'); });
    });
    it('should validate basic client view', function () {
        e2e_utils_1.loadServerView()
            .then(function () { return e2e_utils_1.loadClientView(); })
            .then(function () { return protractor_1.element(protractor_1.by.css('h1')).getText(); })
            .then(function (text) { return expect(text).toEqual('client view'); });
    });
    it('should validate typing input to a text box', function () {
        var input = 'foo man choo';
        e2e_utils_1.loadServerView()
            .then(function () { return protractor_1.element(protractor_1.by.css('#myTextBox')).click(); })
            .then(function () { return protractor_1.browser.actions().sendKeys(input).perform(); })
            .then(function () { return e2e_utils_1.loadClientView(); })
            .then(function () { return protractor_1.element(protractor_1.by.css('#myTextBox')).getAttribute('value'); })
            .then(function (actual) { return expect(actual).toEqual(input); });
    });
    it('should validate choosing from a select', function () {
        var expected = 'foo';
        e2e_utils_1.loadServerView()
            .then(function () { return protractor_1.element(protractor_1.by.css('#mySelect')).click(); })
            .then(function () { return protractor_1.element(protractor_1.by.css('#myVal')).click(); })
            .then(function () { return e2e_utils_1.loadClientView(); })
            .then(function () { return protractor_1.element(protractor_1.by.css('#mySelect')).element(protractor_1.by.css('option:checked')).getText(); })
            .then(function (actual) { return expect(actual).toEqual(expected); });
    });
});
//# sourceMappingURL=e2e.browser.spec.js.map