"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
require("zone.js");
require("zone.js/dist/long-stack-trace-zone.js");
var core_1 = require("@angular/core");
var compiler_1 = require("@angular/compiler");
var platform_server_1 = require("@angular/platform-server");
var e2e_server_module_1 = require("./e2e.server.module");
var fs = require("fs");
var path = require("path");
// get the JIT compiler (not exposed publically, so need to inject it)
var injector = core_1.ReflectiveInjector.resolveAndCreate([compiler_1.COMPILER_PROVIDERS]);
var jitCompiler = injector.get(compiler_1.JitCompiler);
// use the JIT compiler to turn our AppModule into a factory
jitCompiler.compileModuleAsync(e2e_server_module_1.AppModule)
    .then(function (factory) { return platform_server_1.renderModuleFactory(factory, {
    url: '/',
    document: "\n      <html>\n        <head>\n          <title>Preboot Test</title>\n        </head>\n        <body>\n          <app-root></app-root>\n        </body>\n      </html>\n    "
}); })
    .then(function (html) {
    var filePath = path.join(process.cwd(), 'test/e2e/dist/index.html');
    fs.writeFileSync(filePath, html);
})
    .catch(console.error);
//# sourceMappingURL=e2e.server.gen.js.map