"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var protractor_1 = require("protractor");
function loadServerView() {
    protractor_1.browser.waitForAngularEnabled(false);
    return protractor_1.browser.get('http://localhost:4201/')
        .then(function () { return protractor_1.browser.refresh(); });
}
exports.loadServerView = loadServerView;
function loadClientView() {
    return loadClientScript()
        .then(function () { return protractor_1.browser.executeScript('bootstrapPrebootClient()'); });
}
exports.loadClientView = loadClientView;
function loadClientScript() {
    return new Promise(function (resolve) {
        protractor_1.browser.executeScript(function () {
            console.log('executeScript()');
            var scriptTag = document.createElement('script');
            scriptTag.type = 'text/javascript';
            scriptTag.src = '/e2e.browser.js';
            document.getElementsByTagName('head')[0].appendChild(scriptTag);
        });
        waitUntilExists(resolve);
    });
}
exports.loadClientScript = loadClientScript;
function waitUntilExists(done) {
    protractor_1.browser.executeScript(function () {
        return (typeof bootstrapPrebootClient !== 'undefined');
    })
        .then(function (keyExists) {
        if (keyExists) {
            done();
        }
        else {
            setTimeout(function () { return waitUntilExists(done); }, 10);
        }
    });
}
exports.waitUntilExists = waitUntilExists;
//# sourceMappingURL=e2e.utils.js.map