"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
require("jasmine");
var src_1 = require("../../../src");
var utils_1 = require("../../utils");
describe('UNIT TEST get-node-key', function () {
    describe('getNodeKeyForPreboot()', function () {
        it('should generate a default name', function () {
            var nodeContext = {
                root: {
                    serverSelector: '#myApp',
                    clientSelector: '#myApp',
                    serverNode: {},
                    clientNode: {},
                },
                node: {}
            };
            var expected = 'unknown_#myApp';
            var actual = src_1.getNodeKeyForPreboot(nodeContext);
            expect(actual).toEqual(expected);
        });
        it('should generate a name for a deeply nested element', function () {
            var node = { nodeName: 'foo' };
            var nodeContext = {
                root: {
                    serverSelector: '#myApp',
                    serverNode: {
                        childNodes: [{}, {}, { childNodes: [{}, { childNodes: [{}, {}, {}, node] }] }]
                    },
                    clientNode: {}
                },
                node: node
            };
            // add parent references to the rootServerNode tree
            utils_1.addParent(nodeContext.root.serverNode);
            var expected = 'foo_#myApp_s3_s2_s4';
            var actual = src_1.getNodeKeyForPreboot(nodeContext);
            expect(actual).toEqual(expected);
        });
    });
});
//# sourceMappingURL=get-node-key.spec.js.map