"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
require("jasmine");
require("zone.js");
require("zone.js/dist/long-stack-trace-zone.js");
var core_1 = require("@angular/core");
var compiler_1 = require("@angular/compiler");
var platform_server_1 = require("@angular/platform-server");
var platform_browser_1 = require("@angular/platform-browser");
var src_1 = require("../../../src");
describe('UNIT TEST server-preboot.module', function () {
    describe('recordEvents()', function () {
        it('should render on server with JIT compiler', function (done) {
            var AppComponent = /** @class */ (function () {
                function AppComponent() {
                    this.title = 'app works!';
                }
                AppComponent = __decorate([
                    core_1.Component({
                        selector: 'app-root',
                        template: "<h1>{{title}}</h1>",
                    })
                ], AppComponent);
                return AppComponent;
            }());
            var AppModule = /** @class */ (function () {
                function AppModule() {
                }
                AppModule = __decorate([
                    core_1.NgModule({
                        declarations: [AppComponent],
                        imports: [
                            platform_browser_1.BrowserModule.withServerTransition({ appId: 'my-app-id' }),
                            platform_server_1.ServerModule,
                            src_1.ServerPrebootModule.recordEvents({ appRoot: 'app-root' })
                        ],
                        bootstrap: [AppComponent]
                    })
                ], AppModule);
                return AppModule;
            }());
            // get the JIT compiler (not exposed publically, so need to inject it)
            var injector = core_1.ReflectiveInjector.resolveAndCreate([compiler_1.COMPILER_PROVIDERS]);
            var jitCompiler = injector.get(compiler_1.JitCompiler);
            // use the JIT compiler to turn our AppModule into a factory
            return jitCompiler.compileModuleAsync(AppModule)
                .then(function (factory) { return platform_server_1.renderModuleFactory(factory, {
                url: '/',
                document: "\n          <html>\n            <head>\n              <title>Preboot Test</title>\n            </head>\n            <body>\n              <app-root></app-root>\n            </body>\n          </html>\n        "
            }); })
                .then(function (html) {
                expect(html).toMatch(/prebootData/);
                expect(html).toMatch(/app works/);
                done();
            })
                .catch(done);
        });
    });
});
//# sourceMappingURL=server-preboot.module.spec.js.map